SystemOrganization addCategory: #'Pier-Gallery-Model'!
SystemOrganization addCategory: #'Pier-Gallery-Seaside'!
SystemOrganization addCategory: #'Pier-Gallery-Commands'!
SystemOrganization addCategory: #'Pier-Gallery-ImageGenerator'!

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ false! !

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isPicture
	^ false! !

!PRViewRenderer methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'NR 7/4/2009 23:17'!
visitPicture: aPicture
	PGPictureHtmlView new setContext: self context; setPicture: aPicture; renderContentOn: html 
! !

PRWidget subclass: #PGGalleryRandomizer
	instanceVariableNames: 'candidates current'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

!PGGalleryRandomizer class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:05'!
descriptionKeep
	^ MABooleanDescription new
		comment: 'Keep the same random child during the lifetime of a session';
		accessor: #keep;
		default: true;
		priority: 100;
		label: 'Keep';
		yourself! !

!PGGalleryRandomizer class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:06'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add children to this widget'! !

!PGGalleryRandomizer class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:06'!
isAbstract
	^ false! !

!PGGalleryRandomizer class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:06'!
label
	^ 'Gallery-Randomizer'! !

!PGGalleryRandomizer methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:05'!
candidates
	| c p t |
	^ candidates ifNil: [
		c := OrderedCollection new.
		t := self owner enumerator contents.
		t do: [:e|
			(e isKindOf: PGGallery) ifTrue: [
				p := e allPicturesIn: self context.
				p do: [:i|
					(i hide) ifFalse: [
						c add: i
					]
				]
			]
		].
		candidates := c 
	]
! !

!PGGalleryRandomizer methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 00:05'!
current
	"Answer the current structure to display."

	(current isNil or: [ (self read: #descriptionKeep) not ]) ifTrue: [
		current := self candidates isEmpty
			ifFalse: [ self candidates atRandom ]
			ifTrue: [ NoChildrenFound ]].
		
	^ current! !

!PGGalleryRandomizer methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 02:09'!
renderContentOn: html 
	| cur |
	cur := self current.
	"
		self owner parent name, '/',
		self owner name, '/', cur parent name;
	"
	html anchor
		url: self owner parent name , '/' , cur parent title;
		with: 
			[ html image
				width: '320px';
				url: cur representationImageURL ]! !

PRCase subclass: #PGGallery
	instanceVariableNames: 'folder thumbnailWidth representationWidth batchSize galleryPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

PGGallery class
	instanceVariableNames: 'globalLocalPicturesPath globalPicturePath globalPicturesPath globalLocalOriginalPicturesPath'!

PGGallery class
	instanceVariableNames: 'globalLocalPicturesPath globalPicturePath globalPicturesPath globalLocalOriginalPicturesPath'!

PGGallery subclass: #PGGalleriesList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGGalleriesList class methodsFor: 'as yet unclassified' stamp: 'NR 2/4/2009 04:20'!
canBeParentOf: aStructureClass
	^ aStructureClass includesBehavior: PGGallery ! !

!PGGalleriesList methodsFor: 'as yet unclassified' stamp: 'NR 2/4/2009 04:17'!
allPicturesIn: aContext
	^ (aContext enumeratorFor: self)
		select: [:child | child isGallery]! !

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:40'!
canBeParentOf: aStructureClass
	^ aStructureClass includesBehavior: PGPicture ! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 01:01'!
descriptionBatchSize
	^ MANumberDescription new
		parameterName: 'batchSize';
		accessor: #batchSize;
		label: 'Number of pictures per page';
		beSearchable;
		beRequired;
		beEditable;
		beInteger;
		bePositive;
		priority: 60;
		yourself! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'NR 7/5/2009 01:00'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		priority: 80;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/6/2009 00:38'!
descriptionGalleryPath
	^ MAStringDescription new
		parameterName: 'galleryPath';
		accessor: #galleryPath;
		label: 'Gallery Directory Name';
		beSearchable;
		beRequired;
		beEditable;
		priority: 30;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 8/14/2009 04:06'!
descriptionLocalOriginalPicturesPath
	^ MAStringDescription new
		parameterName: 'localOriginalPicturesPath';
		accessor: #localOriginalPicturesPath;
		label: 'Root local original pictures path';
		beSearchable;
		beRequired;
		beEditable;
		priority: 20;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 00:50'!
descriptionLocalPicturesPath
	^ MAStringDescription new
		parameterName: 'localPicturesPath';
		accessor: #localPicturesPath;
		label: 'Root local pictures path';
		beSearchable;
		beRequired;
		beEditable;
		priority: 20;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 00:50'!
descriptionPicturesPath
	^ MAStringDescription new
		parameterName: 'picturesPath';
		accessor: #picturesPath;
		label: 'Root Pictures Path';
		beSearchable;
		beRequired;
		beEditable;
		priority: 10;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 03:43'!
descriptionRepresentationSize
	^ MANumberDescription new
		parameterName: 'representationSize';
		accessor: #representationSize;
		label: 'image width (in px)';
		beSearchable;
		beRequired;
		beEditable;
		beInteger;
		bePositive;
		priority: 40;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 03:43'!
descriptionThumbnailSize
	^ MANumberDescription new
		parameterName: 'thumbnailSize';
		accessor: #thumbnailSize;
		label: 'thumbnail width (in px)';
		beSearchable;
		beRequired;
		beEditable;
		beInteger;
		bePositive;
		priority: 50;
		yourself! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'NR 7/5/2009 01:00'!
descriptionTitle
	^ super descriptionTitle
		comment: 'Title of the gallery';
		priority: 70;
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 8/14/2009 03:52'!
globalLocalOriginalPicturesPath
	^ globalLocalOriginalPicturesPath ifNil: [ globalLocalOriginalPicturesPath := '/tmp' ]! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 8/14/2009 03:53'!
globalLocalOriginalPicturesPath: path
	globalLocalOriginalPicturesPath := path! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 04:08'!
globalLocalPicturesPath
	^ globalLocalPicturesPath ifNil: [ globalLocalPicturesPath := '/tmp' ]! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/2/2009 01:17'!
globalLocalPicturesPath: path
	globalLocalPicturesPath := path! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/5/2009 04:08'!
globalPicturesPath
	^ globalPicturesPath ifNil: [ globalPicturesPath := 'http://localhost/' ]! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/2/2009 01:11'!
globalPicturesPath: path
	globalPicturesPath := path! !

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:24'!
isAbstract
	^ false! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/6/2009 00:31'!
representationsDirectoryName
	^ 'images/'
! !

!PGGallery class methodsFor: 'testing' stamp: 'NR 7/6/2009 00:29'!
thumbnailsDirectoryName
	^ 'thumbnails/'
! !

!PGGallery methodsFor: 'visiting' stamp: 'NR 7/2/2009 01:27'!
accept: aVisitor
	self folder.
	aVisitor visitGallery: self! !

!PGGallery methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 13:20'!
allPicturesIn: aContext
	^ (aContext enumeratorFor: self)
		select: [:child | child isPicture]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 00:59'!
batchSize
	^ batchSize ifNil: [ batchSize := 1000 ]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 00:59'!
batchSize: size
	^ batchSize := size! !

!PGGallery methodsFor: 'visiting' stamp: 'NR 8/14/2009 04:03'!
folder
	" Create the folder if necessary "
	folder ifNil: 
		[ folder := PGGallery globalLocalOriginalPicturesPath asRio / self galleryPath.
		folder exists ifFalse: [ folder mkdir ].
		representationWidth ifNotNil: [ self parseFolder ] ].
	^ folder! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/6/2009 00:37'!
galleryPath
	^ galleryPath ifNil: [ galleryPath := self name ]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/6/2009 00:37'!
galleryPath: aName 
	galleryPath := aName.
	folder := nil! !

!PGGallery methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ true! !

!PGGallery methodsFor: 'testing' stamp: 'lr 12/17/2008 13:55'!
isValidView: aComponentClass in: aContext
	^ aComponentClass = self viewComponentClass or: [ (aComponentClass includesBehavior: PRDefaultView) not ]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 8/14/2009 04:05'!
localOriginalPicturesPath
	^ PGGallery globalLocalOriginalPicturesPath! !

!PGGallery methodsFor: 'testing' stamp: 'NR 8/14/2009 04:05'!
localOriginalPicturesPath: path
	PGGallery globalLocalOriginalPicturesPath: path! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/2/2009 01:18'!
localPicturesPath
	^ PGGallery globalLocalPicturesPath! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/2/2009 01:18'!
localPicturesPath: path
	PGGallery globalLocalPicturesPath: path! !

!PGGallery methodsFor: 'visiting' stamp: 'NR 8/14/2009 03:55'!
parseFolder
	| entries picture dir finalChildren currentChildren validImage exists |
	currentChildren := self childrenDecoration children copy.
	finalChildren := OrderedCollection new.

	"we first remove all our children"
	currentChildren do: [ :e | e remove ].
	
	"then we look up what we have in the directory"
	entries := self folder entries.
	dir := self galleryPath asRio.
	entries do: [ :e | 
		validImage := PGSqueakImageAssistant validFile: (PGGallery globalLocalOriginalPicturesPath), (dir / e name).
		"if what we have is an image we can add it"
		validImage ifTrue: [
			"but first we check if we don't already had it, so that we 
			can reuse the instance and not lose any modifications (rotate..)"
			exists := false.
			currentChildren do: [:each|
				(each name = e name) ifTrue: [
					exists := true.
					finalChildren add: each.
				]
			].
			"if it's a new file we create a new PGPicture'"
			exists ifFalse: [
				picture := PGPicture named: e name.
				picture file: dir / e name.
				picture dir: self galleryPath.
				finalChildren add: picture.
			]
		]
	].
	finalChildren do: [:each|
		" we simply skip if there is an error adding the child"			
		[ 
			self addChild: each.
			each updatePaths.
			each createImageRepresentation 
		] on: Error do: [ :x | 
			Transcript show: 'Error: ' , x messageText; cr 
		] 
	]
! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/2/2009 01:12'!
picturesPath
	^ PGGallery globalPicturesPath! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/2/2009 01:12'!
picturesPath: path
	PGGallery globalPicturesPath: path! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 03:40'!
representationSize
	^ representationWidth ifNil: [ representationWidth := 600 ]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 03:41'!
representationSize: aSize 
	representationWidth := aSize! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 03:42'!
thumbnailSize
	^ thumbnailWidth ifNil: [ thumbnailWidth := 80 ]! !

!PGGallery methodsFor: 'testing' stamp: 'NR 7/5/2009 03:41'!
thumbnailSize: aSize 
	thumbnailWidth := aSize! !

!PGGallery methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 13:46'!
viewComponentClass
	^ PGGalleryHtmlView ! !

PRCase subclass: #PGPicture
	instanceVariableNames: 'fileStructure thumbnail maxImage hide dir angle localRepresentationDir localRepresentationFile localThumbDir localThumbFile remoteThumbDir remoteThumbFile remoteRepresentationDir remoteRepresentationFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:39'!
canBeChildOf: aClass
	^ aClass includesBehavior: PGGallery ! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:33'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/19/2008 13:39'!
descriptionFile
	^ PRFile descriptionFile
		addCondition: [:file | file isImage] labelled: 'Only pictures can be added to a gallery'! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:32'!
descriptionTitle
	^ super descriptionTitle 
		comment: 'Title of the picture';
		yourself! !

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:41'!
isAbstract
	^ false! !

!PGPicture class methodsFor: 'testing' stamp: 'NR 7/3/2009 10:59'!
viewComponentClass
	^ PGPictureHtmlView! !

!PGPicture methodsFor: 'visiting' stamp: 'damiencassou 11/18/2008 13:28'!
accept: aVisitor
	aVisitor visitPicture: self! !

!PGPicture methodsFor: 'image-manipulations' stamp: 'NR 7/3/2009 07:04'!
angle
  angle ifNil: [
	angle := 0.
  ].
  ^ angle.
! !

!PGPicture methodsFor: 'image-manipulations' stamp: 'NR 7/5/2009 02:56'!
createImageRepresentation
	self createImageRepresentationForced: false! !

!PGPicture methodsFor: 'image-manipulations' stamp: 'NR 8/14/2009 03:58'!
createImageRepresentationForced: forceGenerate 
	| localFile generate |
	generate := forceGenerate.
	generate ifFalse: 
		[ localRepresentationFile exists 
			ifTrue: [ localRepresentationFile fileSize > 0 ifFalse: [ generate := true ] ]
			ifFalse: [ generate := true ] ].
	generate ifTrue: 
		[ localFile := (PGGallery globalLocalOriginalPicturesPath , self file) asRio.
		PGImageRequest 
			image: localFile
			to: localRepresentationFile
			size: self parent representationSize
			angle: self angle.
		PGImageRequest 
			thumbnail: localRepresentationFile
			to: localThumbFile
			size: self parent thumbnailSize ]! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'NR 7/6/2009 00:35'!
dir
	dir ifNil: [ self parent ifNotNil: [ dir := self parent galleryPath ] ].
	^ dir! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'NR 7/4/2009 18:49'!
dir: aDir
	dir := aDir.
! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'damiencassou 11/19/2008 13:36'!
file
	^ self fileStructure file! !

!PGPicture methodsFor: 'accessing-delegated' stamp: 'damiencassou 11/19/2008 13:36'!
file: aFile
	^ self fileStructure file: aFile! !

!PGPicture methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/22/2008 20:12'!
fileStructure
	^ fileStructure ifNil: [fileStructure := PRFile named: '']! !

!PGPicture methodsFor: '*pier-gallery-seaside' stamp: 'NR 7/2/2009 02:46'!
hide
	hide ifNil: [ hide := false ].
	^ hide.! !

!PGPicture methodsFor: '*pier-gallery-seaside' stamp: 'NR 7/2/2009 02:43'!
hide: h
	hide := h.! !

!PGPicture methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:17'!
isPicture
	^ true! !

!PGPicture methodsFor: 'testing' stamp: 'NR 7/5/2009 02:57'!
isReady
	localRepresentationFile exists ifFalse: [ ^ false ].
	localThumbFile exists ifFalse: [ ^ false ].
	^ true! !

!PGPicture methodsFor: 'testing' stamp: 'lr 12/17/2008 13:57'!
isValidView: aComponentClass in: aContext
	^ aComponentClass = self viewComponentClass or: [ (aComponentClass includesBehavior: PRDefaultView) not ]! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 02:12'!
localRepresentationDirForSize: size andAngle: anAngle
	^ ((PGGallery globalLocalPicturesPath), PGGallery representationsDirectoryName, size, '-', anAngle asString, '/', self dir) asRio.! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 02:13'!
localThumbDirForSize: size
	^ ((PGGallery globalLocalPicturesPath), PGGallery thumbnailsDirectoryName, size, '-', self angle asString, '/', self dir) asRio.! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 02:13'!
remoteRepresentationDirForSize: size andAngle: anAngle
	^ ((PGGallery globalPicturesPath), PGGallery representationsDirectoryName, size, '-', anAngle asString, '/', self dir) asRio.! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 02:14'!
remoteThumbDirForSize: size
	^ ((PGGallery globalPicturesPath), PGGallery thumbnailsDirectoryName, size, '-', self angle asString, '/', self dir) asRio.! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 02:56'!
representationImageURL
	localRepresentationFile exists ifFalse: [ self createImageRepresentationForced: true ].
	^ remoteRepresentationFile url! !

!PGPicture methodsFor: 'image-manipulations' stamp: 'NR 7/6/2009 00:28'!
rotateLeft
	angle := (angle - 90).
	(angle < 0) ifTrue: [
		angle := 270
	].
	self updatePaths.
	self createImageRepresentation.
! !

!PGPicture methodsFor: 'image-manipulations' stamp: 'NR 7/6/2009 00:28'!
rotateRight
	angle := (angle + 90).
	(angle > 270) ifTrue: [
		angle := 0
	].
	self updatePaths.
	self createImageRepresentation.
! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 03:42'!
thumbnailImageURL
	localThumbFile exists 
		ifTrue: [ ^ remoteThumbFile url ]
		ifFalse: 
			[ PGImageRequest 
				thumbnail: localRepresentationFile
				to: localThumbFile
				size: self parent thumbnailSize ].
	^ nil! !

!PGPicture methodsFor: 'paths' stamp: 'NR 7/5/2009 03:42'!
updatePaths
	| representationSize thumbnailSize |
	representationSize := self parent representationSize asString , 'px'.
	thumbnailSize := self parent thumbnailSize asString , 'px'.
	localRepresentationDir := self 
		localRepresentationDirForSize: representationSize
		andAngle: self angle.
	localRepresentationFile := localRepresentationDir / self file name.
	localThumbDir := self localThumbDirForSize: thumbnailSize.
	localThumbFile := localThumbDir / self file name.
	remoteRepresentationDir := self 
		remoteRepresentationDirForSize: representationSize
		andAngle: self angle.
	remoteRepresentationFile := remoteRepresentationDir / self file name.
	remoteThumbDir := self remoteThumbDirForSize: thumbnailSize.
	remoteThumbFile := remoteThumbDir / self file name.
	localRepresentationFile exists ifFalse: [ ^ false ].
	localThumbFile exists ifFalse: [ ^ false ].
	^ true! !

!PGPicture methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 16:32'!
viewComponentClass
	^ PGPictureHtmlView ! !

PRDefaultView subclass: #PGHtmlView
	instanceVariableNames: 'gallery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGHtmlView subclass: #PGGalleryHtmlView
	instanceVariableNames: 'batcher nbPictures nbPicturesReady'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

!PGGalleryHtmlView class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:37'!
isAbstract
	^ false! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 01:01'!
batcher
	^ batcher ifNil: [
		batcher := WABatchedList new items: self pictures; 
								  batchSize: self gallery batchSize
	]! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 15:36'!
children
	^ (Array with: self batcher), (self pictures gather: [:picture | picture componentsIn: self context])! !

!PGGalleryHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:46'!
pictures
	^ self gallery allPicturesIn: self context! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:42'!
renderBatcherOn: html
	(self batcher maxPages = 1)
		ifFalse: [html render: self batcher]! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'NR 7/5/2009 01:20'!
renderContentOn: html
	html heading: self gallery title level: 2.
	self renderPictures: self batcher batch on: html.
	self renderBatcherOn: html! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'NR 7/5/2009 03:42'!
renderPicture: aPicture on: html 
	| galleryPicture |
	aPicture isGallery 
		ifTrue: 
			[ galleryPicture := (aPicture allPicturesIn: self context) first.
			galleryPicture ifNotNil: 
				[ html div
					class: 'gallery-thumb';
					with: 
						[ html div
							class: 'gallery-thumb-image';
							with: 
								[ html anchor
									goto: (self context structure: aPicture);
									with: [ galleryPicture thumbnailImageURL ] ].
						html div
							class: 'gallery-thumb-text';
							with: [ html text: aPicture name ] ] ] ]
		ifFalse: 
			[ aPicture isReady ifTrue: 
				[ nbPicturesReady := nbPicturesReady + 1.
				self context user 
					ifNil: 
						[ " anonymous browsing, we show the direct link"
						html anchor
							url: aPicture representationImageURL;
							rel: 'lightbox[set]';
							with: 
								[ html image
									width: self gallery thumbnailSize asString , 'px';
									url: aPicture thumbnailImageURL ] ]
					ifNotNil: 
						[ " logged browsing, we link to the structure"
						html anchor
							url: self context structure name , '/' , aPicture name;
							with: 
								[ html image
									width: self gallery thumbnailSize asString , 'px';
									url: aPicture thumbnailImageURL ] ] ] ]! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'NR 7/4/2009 22:06'!
renderPictures: pictures on: html
	| nb |
	nbPictures := 0.
	nbPicturesReady := 0.
	pictures do: [:picture |
		picture hide ifFalse: [
			self renderPicture: picture on: html.
			html text: ' '.
			nbPictures := nbPictures + 1.
		]
	].
	(nbPictures > nbPicturesReady) ifTrue: [
		html break.
		nb := (nbPictures - nbPicturesReady).
		(nb > 1) ifTrue: [
			html text: nb asString, ' pictures left to process...'
		] ifFalse: [
			html text: nb asString, ' picture left to process...'
		]
	]! !

!PGHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 16:29'!
gallery
	^ gallery ifNil: [ gallery := self find: PGGallery]! !

PGHtmlView subclass: #PGPictureHtmlView
	instanceVariableNames: 'picture width embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

!PGPictureHtmlView class methodsFor: 'as yet unclassified' stamp: 'NR 7/3/2009 10:57'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isKindOf: PGPicture ]! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/4/2009 23:33'!
embedded
	embedded ifNil: [ embedded := false ].
	^ embedded! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/3/2009 12:03'!
embedded: isEmbedded
	embedded := isEmbedded! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:13'!
go: struct
	struct ifNotNil: [
		self context: (self context structure: struct)
	]
! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'NR 7/2/2009 02:42'!
hideSwitch
	(self picture hide) ifTrue: [
		self picture hide: false
	] ifFalse: [
		self picture hide: true
	]! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:07'!
next
	| nextStructure |
	nextStructure := self nextStructure.
	nextStructure ifNotNil: [
		self context: (self context structure: nextStructure)
	]
! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:09'!
nextStructure
	| array |
	array := self context siblings.
	array := (array copyAfter: self picture).
	array size > 0 ifTrue: [
		^ array first.
	].
	^ nil
! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:55'!
picture
	^ picture ifNil: [picture := self find: PGPicture]! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/3/2009 11:06'!
picture: aPicture
	picture := aPicture! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:08'!
prev
	| prevStructure |
	prevStructure := self prevStructure.
	prevStructure ifNotNil: [
		self context: (self context structure: prevStructure)
	]
! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:09'!
prevStructure
	| array |
	array := self context siblings.
	array := (array copyUpTo: self picture).
	array size > 0 ifTrue: [
		^ array last.
	].
	^ nil
! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'NR 7/6/2009 00:17'!
renderContentOn: html 
	| div |
	self showToolbarOn: html.
	div := html div.
	div attributes 
		at: 'align'
		put: 'center'.
	div
		id: 'picture';
		with: [ html image url: self picture representationImageURL ]! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/3/2009 11:51'!
setPicture: aPicture
	picture := aPicture! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:13'!
showNextOn: html
	| next |
	next := self nextStructure.
	next ifNil: [
		html text: 'next'.
	] ifNotNil: [
		html anchor
			callback: [ self go: next ];
			with: 'next'.
	].
	! !

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'NR 7/6/2009 00:13'!
showPrevOn: html
	| prev |
	prev := self prevStructure.
	prev ifNil: [
		html text: 'prev'.
	] ifNotNil: [
		html anchor
			callback: [ self go: prev ];
			with: 'prev'.
	].
	! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'NR 7/6/2009 00:14'!
showSeparatorOn: html 
	html space.
	html text: '/'.
	html space.
! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'NR 7/6/2009 00:17'!
showToolbarOn: html 
	| showToolbar strHide |
	self picture hide 
		ifTrue: [ strHide := 'show' ]
		ifFalse: [ strHide := 'hide' ].
	strHide := strHide , ' the image'.
	showToolbar := self embedded not.
	showToolbar ifTrue: [ 
		" check we are logged in"
		self context user ifNil: [ showToolbar := false ] 
	].
	showToolbar ifTrue: [ 
		self showPrevOn: html.
		self showSeparatorOn: html.
		self showNextOn: html.
		self showSeparatorOn: html.
		html anchor
			callback: [ self hideSwitch ];
			with: strHide.
		self showSeparatorOn: html.
		html anchor
			callback: [ self picture rotateLeft ];
			with: 'rotate left '.
		self showSeparatorOn: html.
		html anchor
			callback: [ self picture rotateRight ];
			with: 'rotate right '.
		self showSeparatorOn: html.
		html anchor
			callback: [ self picture createImageRepresentationForced: true ];
			with: 'regenerate '.
		html break.
		html break
	]! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'damiencassou 11/18/2008 13:27'!
visitGallery: aGallery
	self visitCase: aGallery! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'NR 7/3/2009 11:39'!
visitPicture: aPicture
	self visitCase: aPicture! !

Object subclass: #PGImageGenerator
	instanceVariableNames: 'queue process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-ImageGenerator'!

!PGImageGenerator methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 03:00'!
initialize
	queue := SharedQueue new.
	process := [
		| done message |
		done := false.
		Transcript show: 'generator thread started'; cr.
		
		[ done ] whileFalse: [
			message := queue next.
			[
				[
					self process: message
				] on: Error do: [:x|
					Transcript show: 'Exception ', x messageText, ' treating ', message path; cr.
					
				]
			] valueWithin: 60000 milliSeconds onTimeout: [
				" fails after one minute "
				Transcript show: 'timeout treating ', message path; cr.
			]
		]
	] forkAt: Processor lowestPriority.! !

!PGImageGenerator methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 03:39'!
process: message
	message path exists ifTrue: [
		message squared ifTrue: [
			message dest parent mkpath.
			PGSqueakImageAssistant
				scaleSquaredPictureFrom: message path reader
				to: message dest writer
				atSize: message size
		] ifFalse: [
			message dest parent mkpath.
			PGSqueakImageAssistant
				scalePictureFrom: message path reader
				to: message dest writer
				atSize: message size
				andAngle: message angle
		]		
	]
! !

!PGImageGenerator methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:44'!
send: message
	queue nextPut: message! !

Object subclass: #PGImageRequest
	instanceVariableNames: 'path squared size angle dest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-ImageGenerator'!

PGImageRequest class
	instanceVariableNames: 'generator'!

PGImageRequest class
	instanceVariableNames: 'generator'!

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 20:33'!
generator
	generator ifNil: [ generator := PGImageGenerator new ].
	^ generator! !

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 20:36'!
generator: aGenerator
	generator := aGenerator
! !

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 18:38'!
image: path to: dest angle: angle
	| message |
	message := PGImageRequest new path: path; dest: dest; size: 600; angle: angle; squared: false.
	self generator send: message! !

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 03:17'!
image: path to: dest size: size angle: angle
	| message |
	message := PGImageRequest new path: path; dest: dest; size: size; angle: angle; squared: false.
	self generator send: message! !

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:44'!
thumbnail: path to: dest
	| message |
	message := PGImageRequest new path: path; dest: dest; size: 80; squared: true.
	self generator send: message
! !

!PGImageRequest class methodsFor: 'as yet unclassified' stamp: 'NR 7/5/2009 03:18'!
thumbnail: path to: dest size: size
	| message |
	message := PGImageRequest new path: path; dest: dest; size: size; squared: true.
	self generator send: message
! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:32'!
angle
	^ angle! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:05'!
angle: anAngle
	angle := anAngle copy! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:41'!
dest
	^ dest! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:05'!
dest: aDest
	dest := aDest copy! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 18:03'!
initialize
	size := 80.
	squared := true.
	angle := 0.! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:34'!
path
	^ path! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:04'!
path: aPath
	path := aPath copy! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:35'!
size
	^ size! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:06'!
size: aSize
	size := aSize copy
! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 17:36'!
squared
	^ squared! !

!PGImageRequest methodsFor: 'as yet unclassified' stamp: 'NR 7/4/2009 21:06'!
squared: isSquared
	squared := isSquared copy! !

Object subclass: #PGSqueakImageAssistant
	instanceVariableNames: 'file extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Commands'!

!PGSqueakImageAssistant class methodsFor: 'actions' stamp: 'NR 7/5/2009 03:02'!
scalePictureFrom: fileStream to: outputStream atSize: size andAngle: angle
	| original streamClass scaled direction writer |
	original := ImageReadWriter formFromStream: fileStream.
	(angle = 0) ifFalse: [
		(angle = 90) ifTrue: [
			direction := #right
		].
		(angle = 180) ifTrue: [
			direction := #pi
		].
		(angle = 270) ifTrue: [
			direction := #left
		].
		original := original rotateBy: direction centerAt: original center
	].
	scaled := original scaledToSize: size@size.
	[
		writer := JPEGReadWriter2 on: outputStream.
		Cursor write showWhile: [
			writer nextPutImage: scaled quality: 100 progressiveJPEG: true
		]
		writer close.
	] on: Error do: [
		streamClass := self streamClassFor: fileStream ifNone: [self error: 'image format not recognized'].
		streamClass putForm: scaled onStream: outputStream.
	]
! !

!PGSqueakImageAssistant class methodsFor: 'actions' stamp: 'NR 7/5/2009 03:02'!
scaleSquaredPictureFrom: fileStream to: outputStream atSize: size
	| original streamClass scaled h w d newExtent crop writer |
	original := ImageReadWriter formFromStream: fileStream.
	size ifNil: [^ nil].
	
	h := original height.
	w := original width.
	(w > h) ifTrue: [
		newExtent := (size * w / h)@size
	] ifFalse: [
		newExtent := size@(size * h / w)
	].
	
	scaled := original scaledToSize: newExtent.
	
	h := scaled height.
	w := scaled width.
	(w > h) ifTrue: [
		d := ((w - h) / 2) asInteger.
		newExtent := (d@0 extent: size@size).
	] ifFalse: [
		d := ((h - w) / 2) asInteger.
		newExtent := (0@d extent: size@size).
	].

	crop := scaled contentsOfArea: newExtent. 

	[
		writer := JPEGReadWriter2 on: outputStream.
		Cursor write showWhile: [
			writer nextPutImage: crop quality: 100 progressiveJPEG: true
		]
		writer close.
	] on: Error do: [
		streamClass := self streamClassFor: fileStream ifNone: [self error: 'image format not recognized'].
		streamClass putForm: crop onStream: outputStream.
	]
! !

!PGSqueakImageAssistant class methodsFor: 'accessing' stamp: 'damiencassou 11/22/2008 18:35'!
streamClassFor: aBinaryStream ifNone: aBlock
	^ ImageReadWriter withAllSubclasses
		detect: [:subclass | subclass understandsImageFormat: aBinaryStream]
		ifNone: [
			aBinaryStream close.
			^ aBlock value]! !

!PGSqueakImageAssistant class methodsFor: 'accessing' stamp: 'NR 7/6/2009 00:52'!
validFile: path
	| valid |
	valid := true.
	self streamClassFor: path asRio reader 
			ifNone: [ valid := false ].
	^ valid
! !

PRCommand subclass: #PGImportArchiveCommand
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Commands'!

!PGImportArchiveCommand class methodsFor: 'descriptions' stamp: 'damiencassou 11/22/2008 18:18'!
descriptionFile
	^ PRFile descriptionFile 
		label: 'Zip archive';
		addCondition: [:file | file isApplication] labelled: 'Only zip archives are accepted';
		beRequired;
		yourself! !

!PGImportArchiveCommand class methodsFor: 'testing' stamp: 'damiencassou 11/22/2008 18:04'!
isAbstract
	^ false! !

!PGImportArchiveCommand class methodsFor: 'testing' stamp: 'damiencassou 11/22/2008 18:05'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [aContext structure isGallery]! !

!PGImportArchiveCommand class methodsFor: 'accessing' stamp: 'NR 7/2/2009 01:33'!
label
	^ 'Import Zip with pictures'! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 8/14/2009 04:01'!
addPicture: archiveMember 
	| f stream folder |
	folder := self structure galleryPath.
	f := (PGGallery globalLocalOriginalPicturesPath , '/' , folder , '/' , archiveMember fileName) asRio.
	stream := f writer.
	[ stream nextPutAll: archiveMember contentStream contents asByteArray ] ensure: [ stream close ]! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 7/5/2009 03:12'!
doExecute
	| zip |
	super doExecute.
	zip := ZipArchive new readFrom: self file contents readStream; yourself.
	zip members do: [:member | self possiblyAddFile: member].
	zip close.
	self structure parseFolder.! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'damiencassou 11/22/2008 18:21'!
doValidate
	super doValidate.
	(self file subtype = 'zip')
		ifFalse: [MAConditionError description: self description signal: 'Only zip files are accepted']! !

!PGImportArchiveCommand methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/22/2008 18:18'!
file
	^ file! !

!PGImportArchiveCommand methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/22/2008 18:20'!
file: aFile
	file := aFile! !

!PGImportArchiveCommand methodsFor: 'events' stamp: 'NR 7/1/2009 23:17'!
possiblyAddFile: archiveMember
	|memberStream |
     memberStream := archiveMember contentStream.
	(PGSqueakImageAssistant streamClassFor: memberStream ifNone: nil)
		ifNotNil: [self addPicture: archiveMember].
	memberStream close.
     ! !

PRCommand subclass: #PGImportLocalFilesCommand
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Commands'!

!PGImportLocalFilesCommand class methodsFor: 'as yet unclassified' stamp: 'NR 7/2/2009 01:32'!
isAbstract
	^ false! !

!PGImportLocalFilesCommand class methodsFor: 'as yet unclassified' stamp: 'NR 7/2/2009 01:32'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [aContext structure isGallery]! !

!PGImportLocalFilesCommand class methodsFor: 'as yet unclassified' stamp: 'NR 7/2/2009 01:33'!
label
	^ 'Import Local Pictures'! !

!PGImportLocalFilesCommand methodsFor: 'as yet unclassified' stamp: 'NR 7/2/2009 01:34'!
doExecute
	super doExecute.
	self structure parseFolder.! !

!PGImportLocalFilesCommand methodsFor: 'as yet unclassified' stamp: 'NR 7/6/2009 00:43'!
saveButton
	^ #save -> 'Import Local Files'! !

!Rio methodsFor: '*pier-gallery-rio' stamp: 'NR 7/5/2009 02:05'!
url
	^ 'http://', executive host, self value! !
PGGalleryRandomizer initialize!
